

/**
 * An implementation of selection sort.
 * 
 * See this class as a sample of how other algorithms should be implemented.
 * It does not have to be changed.
 * 
 * @author Sara Stymne
 *
 */
public class SelectionSortAlgorithm extends SortAlgorithm {

    /**
	 * Constructs an instance of BubbleSort algorithm with the name set.
	 * 
	 *  All algorithms should have a similar constructor!
	 */
	public SelectionSortAlgorithm() {
		super("Selection sort");
	}

    
    /**
	 * Sorts the vector using selection sort
	 * 
	 * The sort() function should always be the main sorting 
     * function of each algorithm
	 * 
	 * @see SortAlgorithm#sort()
	 */
	public void sort() {
		for(int i = 0; i < elementCount()-1 ; ++i) {
			int minIndex = i;
			for(int j = i+1; j < elementCount(); ++j) {
				if (cmp(j, minIndex) < 0) {
					minIndex = j;
				}
			}
			swap(i, minIndex);
		}
	}
	      
}
